      subroutine compute_cp(volume,temperature,alpha,kincompres,cp)
      USE mod_quasi_multistein_param2
      USE mod_constants
      implicit none
      real*8 volume,temperature,alpha,kincompres,cp

      ! locals
      integer j
      real*8 anharm,cv,expx,expx2,expx3,sum1,sum2,x,x3,x4

      call multistein_temperature2(volume,temperature)

      ! harmonic part cv - PCM (16)
      sum1 = 0d0
      do j=1,n_oscillators
        expx = exp(x_e(j))
        sum1 = sum1 + vdos(j) * x_e(j)**2 * expx / (expx - 1d0)**2
      end do

      ! anharmonic part cv - PCM (29)
      sum2 = 0d0
      if ( anharmonicity0 == 0d0 ) then 
        anharm = 0d0
      else
        do j=1,n_oscillators
          x     = x_e(j)
          x3    = x**3
          x4    = x**4
          expx  = exp(x)
          expx2 = expx**2
          expx3 = expx**3
          sum2 = sum2 +                                          &
            vdos(j) * ( 3d0*x3*expx3*(x-2d0) + 12d0*x4*expx2 +   &
                        3d0*x3*expx *(x+2d0)                     &
                      ) / (expx - 1d0)**4
        end do
        ! volume dependent anharmonicity
        anharm = anharmonicity0 * (volume/v0)**zvol_expon
      end if

      cv = 3*n_atoms_perf*gas_constant * ( sum1 - temperature*anharm*sum2/6d0 )

      cp = cv + alpha**2 * kincompres * volume * temperature

      return
      end subroutine compute_cp
