      subroutine compute_entropy(temperature,volume,entropy)
      USE mod_quasi_multistein_param2
      USE mod_constants
      implicit none
      real*8 temperature,volume,entropy

      ! locals
      integer j
      real*8 anharm,contrib_anharm,sum1,sum2, expx,x,x3

      call multistein_temperature2(volume,temperature)

      ! harmonic part entropy - PCM (17)
      sum1 = 0d0
      do j=1,n_oscillators
        expx    = exp(x_e(j))
        sum1 = sum1 + vdos(j) * ( - log( 1d0 - 1d0/expx ) + x_e(j)/( expx-1d0 ) )
      end do

      ! anharmonic part S - PCM (28)
      if ( anharmonicity0 == 0d0 ) then
        contrib_anharm = 0d0
      else
        sum2 = 0d0
        do j=1,n_oscillators
          x     = x_e(j)
          x3    = x**3  
          expx  = exp(x)
          sum2 = sum2 + vdos(j) * ( 3d0*x3*expx*(expx+1d0) / ( expx - 1d0 )**3 )
        end do
        ! volume dependent anharmonicity
        anharm = anharmonicity0 * (volume/v0)**zvol_expon
        contrib_anharm = temperature*anharm*sum2/6d0
      end if

      entropy = 3*n_atoms_perf*gas_constant * ( sum1 - contrib_anharm )

      return
      end subroutine compute_entropy
