     subroutine compute_kvib_anharm(temperature,volume,gamma_v,dgammadv_t,kvib_anh)
     USE mod_quasi_multistein_param2
     USE mod_constants
     implicit none
     real*8 temperature,volume,gamma_v,dgammadv_t,kvib_anh

     ! locals
     integer j
     real*8 sum1,sum2,sum3,sum4, x,x2,x3,x4,expx,expx2,expx3
     real*8 anharm0,anharm1,anharm2
     real*8 kvib_anh1,kvib_anh2,kvib_anh3,kvib_anh4

     sum1=0d0; sum2=0d0; sum3=0d0; sum4=0d0
     do j=1,n_oscillators
       x    = x_e(j)
       x2   = x**2; x3 = x**3; x4 = x**4
       expx = exp(x); expx2=expx**2; expx3=expx**3

       sum1 = sum1 + vdos(j) *                                                &
              (0.5d0*x2 +                                                     &
               ( 3d0*x2*(2d0-x)*expx2 - 3d0*x2*(2d0+x)*expx )/(expx-1d0)**3 &
              )  

       sum2 = sum2 + vdos(j) *                       &
              (x2 +                                  &
               ( expx3*( 12d0*x2 -15d0*x3 +3d0*x4) + &
                 expx2*(-24d0*x2 +12d0*x4 )        + &
                 expx *( 12d0*x2 +15d0*x3 +3d0*x4)   &
               )/(expx-1d0)**4                       &
              )  

       sum3 = sum3 + vdos(j) * ( 0.25d0*x2 + 3d0*x2*expx/(expx-1d0)**2 )  
!>>>   sum3 = sum3 + vdos(j) * ( 0.25d0*x4 + 3d0*x2*expx/(expx-1d0)**2 )  
     end do
     sum4 = sum1 ! only in case without dispersion with both a_j=a and gamma_j=gamma 

     ! volume dependent anharmonicity (0) and its volume derivatives (1,2)
     anharm0 = anharmonicity0 * (volume/v0)**zvol_expon
     anharm1 = anharmonicity0 * (zvol_expon/v0) *                   &
                                (volume/v0)**(zvol_expon-1) 
     anharm2 = anharmonicity0 * (zvol_expon*(zvol_expon-1)/v0**2) * &
                                (volume/v0)**(zvol_expon-2) 

     kvib_anh1 = 0.5d0*n_atoms_perf*gas_constant*temperature**2/volume *   &
                       anharm0 * (gamma_v-volume*dgammadv_t) * sum1 
     kvib_anh2 = 0.5d0*n_atoms_perf*gas_constant*temperature**2/volume *   &
                       anharm0 * gamma_v**2 * sum2 
     kvib_anh3 = 0.5d0*n_atoms_perf*gas_constant*temperature**2 * volume * &
                       anharm2 * sum3
     kvib_anh4 = 0.5d0*n_atoms_perf*gas_constant*temperature**2 *          &
                       anharm1 * gamma_v * sum4 

     ! anharmonic contribution
     kvib_anh = kvib_anh1 + kvib_anh2 + kvib_anh3 - kvib_anh4
 
     return
     end subroutine compute_kvib_anharm
