      real*8 function func_zero(volume)
      USE mod_state_volume
      implicit none
      real*8 volume

      real*8 pressure_out
      real*8 p_static,p_vib,gamma   !(debug - not used)
      logical, parameter :: DEBUG = .false.

      ! Purpose evaluate the target function of an iterative (bisection) computation  
      !    f(V) = P_i - P(V,T_j)
      ! where P_i is a given pressure, T_j a given temperature (mod_state_volume)
      ! and P(V,T_j) is defined by an EOS 

      call equation_of_state2(volume,temperature,p_static,p_vib,gamma,pressure_out)

      func_zero = pressure - pressure_out

      if ( DEBUG ) then
         write(6,111) volume,p_static, p_vib, pressure_out, &
                      gamma, pressure, func_zero
      end if

      return
111   format(/,'DEBUG func_zero: volume(input)= ',d15.7,/, &
              'p_static ........... ',d15.7,/,             &
              'p_vib .............. ',d15.7,/,             &
              'p_total ............ ',d15.7,/,             &
              'gamma .............. ',d15.7,/,             &
              'pressure (target) .. ',d15.7,/,             &
              'func_zero .......... ',d15.7)
      end function func_zero
