      module mod_quasi_multistein_param2
        ! Parameters for a quasi-harmonic multi-Einstein oscillator model
        integer n_oscillators  ! # of discrete einstein oscillators in model
        integer n_atoms_perf   !  0 - # atoms per formula unit
        real*8  v0_st          !  1 - volume of the static lattice
        real*8  k0_st          !  2 - isothermal bulk modulus of the static lattice
        real*8  k0_prime_st    !  3 - pressure derivative of isothermal bulk modulus (stat.lattice)
        real*8  v0             !  4 - real (measurable) volume of the lattice at zero Kelvin and zero pressure
        real*8  gamma_0        !  5 - Grueneisen parameter at zero Kelvin and zero pressure
        real*8  gamma_inf      !  6 - Grueneisen parameter at zero Kelvin and infinite pressure
        real*8  q0             !  7 - Mode q-parameter at zero Kelvin and zero pressure
        real*8  u_ref          !  8 - Reference energy
        real*8  mol_mass       !  9 - Molar mass
        real*8  anharmonicity0 ! 10 - anharmonicity parameter a0 in: a=a0(v/v0)**z
        real*8  zvol_expon     ! 11 - anharmonicity parameter z  in: a=a0(v/v0)**z 
  
        real*8, allocatable, dimension(:):: x_e       ! x_e(j) = theta_e(j)/T
        real*8, allocatable, dimension(:):: theta_e   ! Einstein temperature(s) at volume V(P,T)
        real*8, allocatable, dimension(:):: theta0_e  ! Einstein temperature(s) at zero Kelvin and zero pressure
        real*8, allocatable, dimension(:):: vdos      ! Vibrational density of states (n_oscillators >1) 
      end module mod_quasi_multistein_param2
