      subroutine multistein_temperature2(volume,temperature)
      USE mod_quasi_multistein_param2
      implicit none
      real*8 volume,temperature

      ! compute einstein temperatures for an array of n_oscillators oscillators
      ! result array theta_e is located in mod_quasi_multistein_param

      real*8 volv0
      real*8 expfact

      volv0 = volume/v0

      if ( q0 == 0d0 ) then
        expfact = volv0**(-gamma_0)
      else
        expfact = exp( - gamma_inf* log(volv0) -                   &
                      (gamma_0-gamma_inf)/q0 * ( volv0**q0 - 1d0)  &
                     )
      end if

      ! fill output arrays in mod_quasi_multistein_param2 
      theta_e = theta0_e * expfact   
      x_e     = theta_e / temperature 

      return
      end subroutine multistein_temperature2
