      subroutine pressure_volume_testtemp()
      USE mod_state_volume
      USE mod_quasi_multistein_param2
      implicit none

      integer i
      integer, parameter :: n_volume = 101
      real*8 volume_max,volume_min,d_volume
      real*8, dimension(n_volume) :: volume,p_total,p_static,p_vib,gamma

      ! debug routine - compute pressure for a range of volume
      ! at T=temperature (mod_state_volume) 

      volume_max = 3d0*v0
      volume_min = 0.1d0*volume_max
      d_volume   = (volume_max - volume_min)/(n_volume-1)

      do i=1,n_volume
        volume(i) = volume_max - (i-1)*d_volume
        call equation_of_state2(volume(i),temperature,p_static(i),p_vib(i), &
                                gamma(i),p_total(i) )
      end do
      
      call writdatfile(n_volume,volume,p_static,'P-V_curves/p_static_volume.dat')
      call writdatfile(n_volume,volume,   p_vib,'P-V_curves/p_vib_volume.dat')
      call writdatfile(n_volume,volume,   gamma,'P-V_curves/gamma.dat')
      call writdatfile(n_volume,volume, p_total,'P-V_curves/p_total_volume.dat')

      return
      end subroutine pressure_volume_testtemp
