      subroutine numfilename(namebase,icount,filename)
      implicit none

      integer icount
      character*(*) namebase,filename

      ! Purpose
      ! define a numerical filename extension without leading zero's
      ! name base and extension are separated by period `.'

      ! parameters:
      ! namebase  (i)  name base character string
      ! icount    (i)  integer counter used in file name extension
      ! filename  (i)  output filename characterstring

      ! locals
      integer lenbase,ndecim
      character*10 formatstring

      ! # decimals in icount
      if(icount .gt. 0) then
         ndecim = 1 + int( log10(float(icount) ) )
      else if(icount .eq. 0) then
         ndecim = 1
      else
         write(6,'(/,''ERROR in numfilename: icount='',i6)') icount
      end if

      write(formatstring,'(''(i'',i1,'')'')') ndecim

      lenbase  = len_trim(namebase)
      filename = namebase( 1:lenbase )//'.'
      write(filename(lenbase+2:),formatstring) icount
   
      return
      end subroutine numfilename
